#import <Foundation/Foundation.h>
#include <objc/objc.h>
#include <objc/objc-class.h>

@interface Bar : NSObject
{
}
@end


@interface Foo : Bar
{
}
@end


@implementation Bar
{
}
@end


@implementation Foo
{
}
@end



static void    dump_id( id p, char *prefix)
{
   printf( "%sisa           : %p\n", prefix,  p->isa);
}


static void    dump_objc_class( struct objc_class *p, char *prefix)
{
   printf( "%sisa           : %p\n",  prefix, p->isa);
   printf( "%ssuper_class   : %p\n",  prefix, p->super_class);
   printf( "%sname          : %s\n",  prefix, p->name);
/*   
   printf( "%sversion       : %ld\n", prefix, p->version);
   printf( "%sinfo          : %ld\n", prefix, p->info);
   printf( "%sinstance_size : %ld\n", prefix, p->instance_size);
   printf( "%sivars         : %p\n",  prefix, p->ivars);
   printf( "%smethodLists   : %p\n",  prefix, p->methodLists);
   printf( "%scache         : %p\n",  prefix, p->cache);
   printf( "%sprotocols     : %p\n",  prefix, p->protocols);
*/   
}


void   dump_object( id p)
{
   printf( [[NSString stringWithFormat:@"Object %@ %p\n", p, p] cString]);
   dump_id( p, "\t");
   printf( [[NSString stringWithFormat:@"\tClass %@ %p\n", p->isa, p->isa] cString]);
   dump_objc_class( p->isa, "\t\t");
}


void   dump_class( id p)
{
   printf( [[NSString stringWithFormat:@"Class %@ %p\n", p, p] cString]);
   dump_objc_class( p, "\t");
   printf( [[NSString stringWithFormat:@"\t->isa Class %@ %p\n", p->isa, p->isa] cString]);
   dump_objc_class( p->isa, "\t\t");
}



int main (int argc, const char * argv[]) 
{
   NSAutoreleasePool   *pool = [[NSAutoreleasePool alloc] init];
   Foo                 *foo;
   
   foo = [[Foo new] autorelease];

   dump_object( foo);
   printf( "\n");
   dump_class( [foo class]);
   printf( "\n");
   dump_class( [foo superclass]);
   printf( "\n");
   dump_class( [[foo superclass] superclass]);
   printf( "\n");
   
   [pool release];
   return 0;
}
